import sys
for path in paths:
    sys.path.append(path)
    
input_variable = "in_image"
output_variables = "BrainMask,SkullStripped"
output_types = "seg,input"

error_string = None
del error_string 
try:
    import torch
    import torch.cuda
    from data_loading import load_and_preprocess, get_sitk_from_nparray
    from predict_patient import predict_patient_3D_net
    import imp
    from utils import postprocess_prediction

    cf = imp.load_source('cf', config_file)
    cf = cf.config()

    net, _ = cf.get_network(cf.val_use_train_mode, model_file)
    device = 0
    if not torch.cuda.is_available() or torch.cuda.device_count()<=0:
        net = net.cpu()
        device = 'CPU'
        print('No CUDA or GU found. Using CPU.')
    else:
        device = 0
        net.cuda(device)
        print('Using GPU ', torch.cuda.get_device_name(device))
    data, data_dict = load_and_preprocess(in_image)

    seg, _, _, _ = predict_patient_3D_net(net, cf.preprocess(data.transpose(0, 3, 2, 1)[:, :, ::-1, ::-1]), cf.val_do_mirroring, cf.val_num_repeats, cf.val_batch_size,
                                 cf.net_input_must_be_divisible_by, cf.val_min_size, device, cf.da_mirror_axes)

    seg = seg[:, ::-1, ::-1].transpose(2, 1, 0)
    seg = postprocess_prediction(seg)

    BrainMask, SkullStripped = get_sitk_from_nparray(seg, in_image, data_dict)
except Exception as e:
    error_string = str(e)
    print(error_string)
